#ifndef brianExpert_h
#define brianExpert_h

#include <string.h>

#include <const.h>

#include <brian.h>
#include <getFuzzy.h>

#include "StringModuleMember.h"
#include <const.h>
//#include "mylogger.h"
#include <iomanip>

#ifdef DMALLOC
#include <dmalloc.h>
#endif

extern int MessageLineNum;
#define MOTOR_COMMAND 	"MotorCommand"

#define SPYKEE_NORMAL		-1
#define SPYKEE_TURN_RIGHT	 0
#define SPYKEE_TURN_LEFT	 1
#define SPYKEE_TURN_BACK	 2
#define SPYKEE_AUTO_FORWARD	 3

#define STATUS_SEARCHING 	0
#define STATUS_ESCAPING		1
#define STATUS_HIDING		2

typedef map< string, std::pair<float,float> > BrianMap;

class BrianExpert: public StringModuleMember{
 public:
	static const string msg_always;
 public:
  BrianExpert(ModuleDispatch* dis,long period);
  ~BrianExpert();

  void RunInit();
  void RunDuty();
  void RunClose();

  void ParseStringMessages();
  void FillMessages(command_list * cl, action_list * al, predicate_list * linkcadl, weight_want_list* linkwwl, predicate_list* linkpdl);

  void SetValue(const char * name, float val, float rel);
  void AddValueToMap( const char *name, float val, float rel = 1.0 );

 private:
  enum { MOTOR_AUTO_RIGHT = 0, MOTOR_AUTO_LEFT = 1, MOTOR_NORMAL = -1 };
  int mMotorState;
  int mGameStatus;
  int mEscapeTimeout;
  bool mOldClock;
 
  // function used to keep values in cdl up to date
  //void BuildData(command_list* cl);

  struct timeval last_render[1];
  long elapsed(int);
  void settimer(int);

  void debug();

  MrBrian * TheBrian;

  void AddBehaviorData(string name, float cando_value, float want_value);
  void AddFuzzyData(string name,float value,float reliability);
  void AddCommandData(string name, float value);
  void RemoveMapValue(string name);

  BrianMap mCL;
  //MyLogger mLogger;
  ofstream mLogger;

  ofstream logfile;
  ofstream brianmsglog;
};

#endif
