#include "ControlExpert.h"

ControlExpert::ControlExpert(ModuleDispatch* kernel, int period, SpykeeGui *gui ) : StringModuleMember(kernel, period, "ControlExpert" ){	
	
	printf( "Controls\n" );
	m_gui = gui;
	if ( m_gui )
		m_gui->setControl(this);
}

ControlExpert::~ControlExpert(){
	
}

void ControlExpert::SendCommandToMotors(int dx, int sx){
	NewMessage(MSG_TO_MOTION, GUI_DATA);
	mCurrentMessage << "Dx " << dx << " Sx " << sx << '\n';
	CloseCurrentMessage();
	SendAllStringMessages();
}

void ControlExpert::RunInit(){
	AddMessageRequest( MSG_TO_GUI, LOCAL );
	AddMessageRequest( MSG_FROM_SONAR, LOCAL );
}

void ControlExpert::RunDuty(){
	if ( m_gui )
		m_gui->process();
}

void ControlExpert::RunClose(){
	
}
