#include "FileLogger.h"

FileLogger::FileLogger( string file, bool bAppend ){
	time_t tt;
	
	m_file.open( file.c_str(), bAppend ? ios::app : ios::out );
	
	time(&tt);
	tm *t = localtime(&tt);
	
	m_file << "--- Log opened @: " << t->tm_mday << '/' << t->tm_mon + 1 << '/' << t->tm_year + 1900 << " - "
								   << t->tm_hour << ':' << t->tm_min << ':' << t->tm_sec << " ---" << endl;
}

FileLogger::~FileLogger(){
	close();
}

void FileLogger::write( string data ){
	m_file << data << flush;
}

void FileLogger::write( const char *fmt, ... ){

}

void FileLogger::writeLine( string line ){
	m_file << line << endl;
}

FileLogger &FileLogger::operator<<( const string &str ){
	m_file << str;
	return *this;
}

FileLogger &FileLogger::operator<<( const char *str ){
	m_file << str;
	return *this;
}

FileLogger &FileLogger::operator<<( const int str ){
	m_file << str;
	return *this;
}

FileLogger &FileLogger::operator<<( const double str ){
	m_file << str;
	return *this;
}
void FileLogger::close(){
	time_t tt;
		
	time(&tt);
	tm *t = localtime(&tt);
	
	m_file << "--- Log closed @: " << t->tm_mday << '/' << t->tm_mon + 1 << '/' << t->tm_year + 1900 << " - "
								   << t->tm_hour << ':' << t->tm_min << ':' << t->tm_sec << " ---" << endl;
	m_file.close();
}
