#include "MotorExpert.h"
#include "msg.h"

#include <iostream>
using namespace std;

extern void motorlex_memory(const char* src, MotorExpert* pMotor);
extern int MessageLineNum;
int needodo=0;

// la parola extern non dichiara un nuovo identificatore, 
// ma dice "La variabile intera a e` dichiarata da qualche altra parte, 
// lascia solo lo spazio per risolvere il riferimento"

//extern void motorlex_memory(const char* src, MotorExpert* pMotor);
//extern int MessageLineNum;

MotorExpert::MotorExpert(ModuleDispatch* kernel,int period, Spykee *s) : StringModuleMember(kernel,period, "MotorExpert"){
	pSpykee = s;
	cout << "\nMotorExpert built" << endl;
};

MotorExpert::~MotorExpert(){
	cout << "\nMotorExpert destroyed" << endl;
};

void MotorExpert::RunInit(){
	AddMessageRequest( MSG_TO_MOTION, LOCAL);
	cout << "\nMotorExpert initialized" << endl;
};

void MotorExpert::RunDuty(){
	float Tan,Rot;
	int flag=0;
	unsigned char* buffer = NULL;

	if(ReceiveLastMessage(MSG_TO_MOTION, buffer,false) > 0){
		mCommandData.clear();
		
		motorlex_memory((const char *)buffer,this);
		//cout << buffer << endl;
		
		dxSpeed = (int)(mCommandData[TAN_SPEED] - mCommandData[ROT_SPEED]);
		sxSpeed = (int)(mCommandData[TAN_SPEED] + mCommandData[ROT_SPEED]);

		if (dxSpeed > 100) dxSpeed = 100;
		if (sxSpeed > 100) sxSpeed = 100;
		
		if (dxSpeed < -100) dxSpeed = -100;
		if (sxSpeed < -100) sxSpeed = -100;

/*		if (dxSpeed < 25 && dxSpeed > 0 ) dxSpeed = 25;
		if (sxSpeed < 25 && sxSpeed > 0 ) sxSpeed = 25;

		if (dxSpeed > 25 && dxSpeed < 0 ) dxSpeed = -25;
		if (sxSpeed > -25 && sxSpeed < 0 ) sxSpeed = -25;
*/
	}
	
	if ( pSpykee ){
		pSpykee->move(sxSpeed, dxSpeed);
		//cout << sxSpeed << " - " << dxSpeed << endl;
	} else {
		cout << sxSpeed << " - " << dxSpeed << endl;
	}
};

void MotorExpert::RunClose(){
	pSpykee->move(0,0);
	cout << "\nMotorExpert closed" << endl;
};


void MotorExpert::SendMotorMessage(){
}

void MotorExpert::AddOdometryData(string name, float value){
  mCurrentMessage << "<" << value << ">";
}


long MotorExpert::elapsed(int i){ 
	struct timeval now;
	long elapsed_usec = 0;

	gettimeofday(&now, NULL);

	if (now.tv_usec > 1000000) {
		now.tv_usec -= 1000000;
		++now.tv_sec;
	}

	if (now.tv_sec > last_render[i].tv_sec){
		elapsed_usec = ((now.tv_sec - last_render[i].tv_sec) * 1000000);
	}

	if (now.tv_usec > last_render[i].tv_usec)
		elapsed_usec += now.tv_usec - last_render[i].tv_usec;
	else
		elapsed_usec -= last_render[i].tv_usec - now.tv_usec;


	return elapsed_usec ;

}

void MotorExpert::settimer(int i){
	gettimeofday(&(last_render[i]),NULL);
}
