#ifndef MotorExpert_h
#define MotorExpert_h

#include "StringModuleMember.h"

#include <sys/time.h>
#include <stdlib.h> 
#include <stdio.h>
#include <const.h>
#include <msg.h>
#include <stl.h>
	
	
#include <Spykee.h>
	
typedef map<string,float> FloatDataListType;

#define TAN_SPEED 		"TanSpeed"
#define ROT_SPEED 		"RotSpeed"
#define MOTOR_COMMAND 	"MotorCommand"

#define SPYKEE_NORMAL		-1
#define SPYKEE_TURN_RIGHT	 0
#define SPYKEE_TURN_LEFT	 1
#define SPYKEE_TURN_BACK	 2

	class MotorExpert : public StringModuleMember{
	 public:
  		MotorExpert (ModuleDispatch* kernel, int period, Spykee* s);
  		~MotorExpert ();
  		
   		void RunInit();
   		void RunClose();
   		void RunDuty();
   		long elapsed(int);
   		void settimer(int);

   		void SendMotorMessage();
   		
		inline void InsertData(string name, float value){
			mCommandData[name] = value;
		}

 		private:
 		struct timeval last_render[10];
   		void AddOdometryData(string name, float value);
   		float old_Tan;
   		float old_Rot;
		Spykee *pSpykee;
		int m_state;
		int dxSpeed,
			sxSpeed;
			
		FloatDataListType mCommandData;		
	};

#endif
