#ifndef SONAR_EXPERT_h
#define SONAR_EXPERT_h


#include "StringModuleMember.h"
#include <deque>
#include <string>
#include <fstream>
#include <iomanip>


#include <sys/time.h>
#include <stdlib.h> 
#include <stdio.h>
#include <const.h>
#include <msg.h>

#include "ReadSonar.h"


#define NORTH 		0
#define SOUTH		6

#define EAST		1
#define WEST		7


class SonarExpert : public StringModuleMember {
public:
	SonarExpert (ModuleDispatch* kernel, std::string name,int period );
	~SonarExpert ();
	
	void RunInit();
	void RunDuty();
	void RunClose();
		
	void SetAllLeds(char c);
	void SetGreenValue( bool b );
	void SetRedValue(char c);
	void SetYellowValue(char c);
	
	//enum { NORTH = 0, SOUTH = 1, NORTH_EAST = 2, EAST = 6, WEST = 7, NORTH_WEST = 8 } SonarChannel;
	

private:
	ReadSonar * readSonar;
	bool m_bInit;
	bool m_bBufferFull;
	
	long elapsed(int i);
	void settimer(int i);
	void AddBrianData(char* name,float value,float rel);

	struct led_status {
		int red : 3;
		int green : 1;
		int yellow : 4;
	};
	
	union {
		char cValue;
		led_status sValue;
	} m_ledValue;

	struct timeval last_render[10];
	int old_sonar_values[2];
	
	vector<int> channels;
	static const int max_line_err=5;
	float to_meter;
	std::string dev;

	std::deque<int> m_lBuffer;
	std::deque<int> m_rBuffer;

	std::ofstream rLog;
	std::ofstream lLog;
};


#endif
