#include "SpykeeGui.h"
#include "ControlExpert.h"
#include <opencv/highgui.h>

SpykeeGui::SpykeeGui( DCDT_Mutex *mutex, int *argc, char ***argv ) : m_quit(false){
	gtk_init(argc, argv);
	
	pMutex = mutex;
	pMainWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	pImage = cvCreateImage( cvSize(320,240), 8, 3 );
	
	// --- Creazione bottoni --- //
	
	// --- Pulsanti direzionali --- //
	pBtnForward = gtk_button_new_with_label("/\\");		gtk_widget_set_size_request(pBtnForward, 30, 30);
	pBtnBackward = gtk_button_new_with_label("\\/");	gtk_widget_set_size_request(pBtnBackward, 30, 30);
	pBtnRight = gtk_button_new_with_label(">");			gtk_widget_set_size_request(pBtnRight, 30, 30);
	pBtnLeft = gtk_button_new_with_label("<");			gtk_widget_set_size_request(pBtnLeft, 30, 30);
	pBtnStop = gtk_button_new_with_label("X");			gtk_widget_set_size_request(pBtnQuit, 30, 30);
	
	pBtnQuit = gtk_button_new_with_label("Quit");
	
	
	// --- Creazione visualizzatore immagini e sonar --- //
	pImageViewer = gtk_image_new();
	gtk_image_set_from_file(GTK_IMAGE(pImageViewer), "./model1.jpg");
	
	pLblNorth = gtk_label_new("North");
	pLblSouth = gtk_label_new("South");
	pLblEast = gtk_label_new("East");
	pLblWest = gtk_label_new("West");
	
	// --- Creazione containers --- //
	pGridButtons = gtk_table_new( 4, 3, FALSE );
	gtk_table_set_row_spacings(GTK_TABLE(pGridButtons), 2);
	gtk_table_set_col_spacings(GTK_TABLE(pGridButtons), 2);
	
	pGridImage = gtk_table_new( 3, 3, FALSE );
	gtk_table_set_row_spacings(GTK_TABLE(pImageViewer), 2 );
	gtk_table_set_col_spacings(GTK_TABLE(pImageViewer), 2 );
	
	pHBox = gtk_hbox_new( FALSE, 2 );
	
	pTopAlign = gtk_alignment_new( 0, 0, 0, 0 );
	
	
	// --- Aggiunta controlli direzionali --- //
	gtk_table_attach_defaults(GTK_TABLE(pGridButtons), pBtnForward, 1, 2, 0, 1 );
	gtk_table_attach_defaults(GTK_TABLE(pGridButtons), pBtnBackward, 1, 2, 2, 3 );
	gtk_table_attach_defaults(GTK_TABLE(pGridButtons), pBtnRight, 2, 3, 1, 2 );
	gtk_table_attach_defaults(GTK_TABLE(pGridButtons), pBtnLeft, 0, 1, 1, 2 );
	gtk_table_attach_defaults(GTK_TABLE(pGridButtons), pBtnStop, 1, 2, 1, 2 );
	gtk_table_attach_defaults(GTK_TABLE(pGridButtons), pBtnQuit, 3, 4, 0, 1 );
	
		
	// --- Aggiunta controlli immagine e sonar --- //	
	gtk_table_attach_defaults(GTK_TABLE(pGridImage), pImageViewer, 1, 2, 1, 2 );
	gtk_table_attach_defaults(GTK_TABLE(pGridImage), pLblNorth, 1, 2, 0, 1 );
	gtk_table_attach_defaults(GTK_TABLE(pGridImage), pLblSouth, 1, 2, 2, 3 );
	gtk_table_attach_defaults(GTK_TABLE(pGridImage), pLblEast, 2, 3, 1, 2 );
	gtk_table_attach_defaults(GTK_TABLE(pGridImage), pLblWest, 0, 1, 1, 2 );
	
	
	// --- Dimensioni e posizione della finestra principale --- //
	gtk_window_set_position(GTK_WINDOW(pMainWindow), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size(GTK_WINDOW(pMainWindow), 800, 600);


	// --- Aggiunta containers alla finestra principale --- //
	gtk_container_add(GTK_CONTAINER(pHBox), pGridImage );
	gtk_container_add(GTK_CONTAINER(pHBox), pGridButtons );
	gtk_container_add(GTK_CONTAINER(pTopAlign), pHBox );
	
	gtk_container_add(GTK_CONTAINER(pMainWindow), pTopAlign );
	
	
	// --- Signals --- //	
	g_signal_connect(G_OBJECT(pBtnForward), "pressed", G_CALLBACK(forward_button_pressed), this);
	g_signal_connect(G_OBJECT(pBtnBackward), "pressed", G_CALLBACK(backward_button_pressed), this);
	g_signal_connect(G_OBJECT(pBtnRight), "pressed", G_CALLBACK(right_button_pressed), this);
	g_signal_connect(G_OBJECT(pBtnLeft), "pressed", G_CALLBACK(left_button_pressed), this);
	g_signal_connect(G_OBJECT(pBtnStop), "pressed", G_CALLBACK(stop_button_pressed), this);
	
	g_signal_connect(G_OBJECT(pBtnQuit), "clicked", G_CALLBACK(quit_clicked), this );
	g_signal_connect(G_OBJECT(pMainWindow), "destroy", G_CALLBACK(shutdown), this );
	
	gtk_widget_show_all(pMainWindow);
	gtk_quit_add( 0, shutdown, NULL );
}

SpykeeGui::~SpykeeGui(){
	cvReleaseImage(&pImage);
}

void SpykeeGui::setControl( ControlExpert *ptr ){
	this->pExpert = ptr;
}

void SpykeeGui::forward_button_pressed(GtkWidget *widget, gpointer data ){
	SpykeeGui *pGui = ((SpykeeGui*)data);
	//pGui->pExpert->SendCommandToMotors(80, 80);
}

void SpykeeGui::backward_button_pressed(GtkWidget *widget, gpointer data ){
	SpykeeGui *pGui = ((SpykeeGui*)data);
	//pGui->pExpert->SendCommandToMotors(-80, -80);
}

void SpykeeGui::right_button_pressed(GtkWidget *widget, gpointer data ){
	SpykeeGui *pGui = ((SpykeeGui*)data);
	//pGui->pExpert->SendCommandToMotors(50, -50);
}

void SpykeeGui::left_button_pressed(GtkWidget *widget, gpointer data ){
	SpykeeGui *pGui = ((SpykeeGui*)data);
	//pGui->pExpert->SendCommandToMotors(-50, 50);
}

void SpykeeGui::stop_button_pressed(GtkWidget *widget, gpointer data ){
	SpykeeGui *pGui = ((SpykeeGui*)data);
//	pGui->pExpert->SendCommandToMotors(0, 0);
}
	
void SpykeeGui::quit_clicked(GtkWidget *widget, gpointer data){
	SpykeeGui *pGui = ((SpykeeGui*)data);
	pGui->m_quit = true;
}

gboolean SpykeeGui::shutdown( gpointer data ){
	SpykeeGui *pGui = ((SpykeeGui*)data);
	pGui->pExpert->Shutdown(1);
}

bool SpykeeGui::quitRequest(){
	return m_quit;
}

void SpykeeGui::process(){
	gtk_main_iteration_do(FALSE);
	
	if ( m_quit )
		pExpert->Shutdown(1);
		
		
	unsigned char* buffer;
	if( pExpert->ReceiveLastMessage(MSG_FROM_SONAR, buffer,false) > 0 ){
		float n;
		int i, tot = 0;
		char lblBuf[10]={0};
		
		for(i=0;buffer[i]!=NULL;i++);
		
    	char* buf=(char*)malloc(i+1);
    	strcpy(buf,(char*)buffer);
    	
    	if ( pExpert->strtovalue(buf, "SonarFront ", &n ) ){
			sprintf( lblBuf, "%d", (int)n );
			gtk_label_set_text( GTK_LABEL(pLblNorth), lblBuf );
		}
		
		if ( pExpert->strtovalue(buf, "SonarBack ", &n ) ){
			sprintf( lblBuf, "%d", (int)n );
			gtk_label_set_text( GTK_LABEL(pLblSouth), lblBuf );
		}
		
		if ( pExpert->strtovalue(buf, "SonarRight ", &n ) ){
			sprintf( lblBuf, "%d", (int)n );
			gtk_label_set_text( GTK_LABEL(pLblEast), lblBuf );
		}
		
		if ( pExpert->strtovalue(buf, "SonarLeft ", &n ) ){
			sprintf( lblBuf, "%d", (int)n );
			gtk_label_set_text( GTK_LABEL(pLblWest), lblBuf );
		}
			
    	free(buf);
	}
}

void SpykeeGui::showImage( IplImage *ocvImage ){
	pMutex->lock();

	cvConvertImage( ocvImage, pImage, CV_CVTIMG_SWAP_RB );

	GdkPixbuf *pixBuffer = gdk_pixbuf_new_from_data ((guchar*)pImage->imageData, GDK_COLORSPACE_RGB, FALSE, pImage->depth,
			pImage->width, pImage->height, (pImage->widthStep), NULL, NULL);

	//gtk_image_clear( GTK_IMAGE(pImageViewer) );
	gtk_image_set_from_pixbuf( GTK_IMAGE(pImageViewer), pixBuffer );
	g_object_unref(pixBuffer);

	pMutex->unlock();
}
