#ifndef SPYKEE_GUI_H
#define SPYKEE_GUI_H

#include <gtk/gtk.h>
#include <DCDT_Defs.h>
#include <opencv/cv.h>

class ControlExpert;

class SpykeeGui {
	public:
	SpykeeGui( DCDT_Mutex *mutex, int *argc, char ***argv );
	~SpykeeGui();
	
	void setControl( ControlExpert *ptr );
	
	void process();
	void showImage( IplImage *ocvImage );
	bool quitRequest();
	
	DCDT_Mutex *getMutex(){ return pMutex; }

	private:
	
	// Signals
	static void quit_clicked(GtkWidget *widget, gpointer data);
	
	static void forward_button_pressed(GtkWidget *widget, gpointer data );
	static void backward_button_pressed(GtkWidget *widget, gpointer data );
	static void right_button_pressed(GtkWidget *widget, gpointer data );
	static void left_button_pressed(GtkWidget *widget, gpointer data );
	static void stop_button_pressed(GtkWidget *widget, gpointer data );
	
	
	static gboolean shutdown( gpointer data );
	
	GtkWidget *pMainWindow;	
	
	
	//Container
	GtkWidget *pGridButtons;
	GtkWidget *pGridImage;
	GtkWidget *pHBox;
	
	//Aligns
	GtkWidget *pTopAlign;
	
	//Image from spykee
	GtkWidget *pImageViewer;
	
	
	//Buttons
	GtkWidget *pBtnForward,
			  *pBtnBackward,
			  *pBtnRight,
			  *pBtnLeft,
			  *pBtnStop;
			  
	GtkWidget *pBtnQuit;

	
	//Sonar labels
	GtkWidget *pLblNorth,
			  *pLblSouth,
			  *pLblEast,
			  *pLblWest;
			  
	bool m_quit;
	
	ControlExpert *pExpert;
	IplImage *pImage;
	
	DCDT_Mutex *pMutex;
};

#endif
