#ifndef WiimExpert_h
#define WiimExpert_h

#include "StringModuleMember.h"

#include <sys/time.h>
#include <cstdlib>
#include <cstdio>
#include <const.h>
#include <msg.h>
#include <wiim.h>
#include <wiiuse.h>
#include <Spykee.h>

typedef map<string,float> FloatDataListType;

class WiimExpert : public StringModuleMember{
	public:
  		WiimExpert (ModuleDispatch* kernel, int period, Spykee*);
  		~WiimExpert ();
   		void RunInit();
   		void RunClose();
   		void RunDuty();
   		void setRotDirection(int dir);
   		
		//int distances[SENSORS_NUMBER * 2];
		bool m_bAuto;
		
		inline void InsertData(string name, float value){
			mCommandData[name] = value;
		}

 	private:

   		Wiim* wiim;
   		int canDo();
   		void calculateposition();
   		long elapsed(int);
   		void settimer(int);
   		void AddBrianData(char*,float,float);
   		void printstatus();
   			
   		struct timeval last_render[10];
   		float charged;
		int Hit;
		int gHome;
		int restartflag;
		int rotflag;
		int fps;
		int random_sign;
		int goForward;

   		pos home;
   		pos goal;
   		pos center;
   		pos rob;
   		int angoloOdo;
   		
   		ppoint position;

		int robotpoint;
		int humanpoint;
		int pointrobotflag;
		
		float maxx,maxy,minx,miny;
		
		weightfloat ir_centerarray_x[IRCENTERFILTER];
		weightfloat ir_centerarray_y[IRCENTERFILTER];
		int distances_buffer[4];
		
		float base_time;
		FILE* fp;
		FILE* f;
		
		bool playing;
		int clock;
		bool cameraLightOn;

		Spykee* pSpykee;
		FloatDataListType mCommandData;
		
	};
#endif
