#include "mylogger.h"


MyLogger::MyLogger(){

}

MyLogger::MyLogger( const string &path, bool bAppend ){
	m_files.push_back( new ofstream(path.c_str()) );
}

MyLogger::~MyLogger(){
	close();
}

void MyLogger::addFile( const string &path, bool bAppend ){
	m_files.push_back( new ofstream(path.c_str()) );
}

void MyLogger::addFile( ofstream &out ){
	// TODO
}

void MyLogger::write( const string &str ){
	for ( vector<ofstream*>::iterator it = m_files.begin(); it != m_files.end(); it++ )
		*(*it) << str << flush;
}

void MyLogger::writeLine( const string &str ){
	for ( vector<ofstream*>::iterator it = m_files.begin(); it != m_files.end(); it++ )
		*(*it) << str << endl;
}

void MyLogger::write( const char *fmt, ... ){
	va_list ap;
	va_start (ap, fmt );
	write_var( fmt, ap, false );
	va_end(ap);
}

void MyLogger::writeLine( const char *fmt, ... ){
	va_list ap;
	va_start (ap, fmt );
	write_var( fmt, ap, true );
	va_end(ap);	
}

void MyLogger::write_var( const char *fmt, va_list ap, bool bNewLine ){
	int size = 512;
	char stackbuf[512] = {0};
	vector<char> dynbuf;
	char *buf = &stackbuf[0];
	
	while ( true ){
		int needed = vsnprintf(buf, size, fmt, ap );
		
		if ( needed <= size && needed >= 0 ){
			write( buf, needed, bNewLine );
			break;
		}
		
		size = ( needed > 0 ? needed + 1 : size * 2 );
		dynbuf.resize(size);
		buf = &dynbuf[0];
	}
}

void MyLogger::write( const char *str, int length, bool bNewLine ){
	for ( vector<ofstream*>::iterator it = m_files.begin(); it != m_files.end(); it++ ){
		if ( *it ){
			(*it)->write( str, length );
			
			if ( bNewLine )
				*(*it) << endl;
			else
				(*it)->flush();
		}	
	}
}

void MyLogger::close(){
	while ( !m_files.empty() ){
		ofstream *f = m_files.back();
		
		if ( f ){
			f->close();
			delete f;
		}
		
		m_files.pop_back();
	}
}
