#ifndef LOGGER_H
#define LOGGER_H

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <ctime>
#include <iomanip>
#include <vector>

#include <cstdarg>

using namespace std;

class MyLogger {
	public:
		MyLogger( const string &path, bool bAppend = true );
		MyLogger();
		~MyLogger();
		
		void addFile( const string &path, bool bAppend = true );
		void addFile( ofstream &out );
		
/*		Logger &operator << ( const string &str );
		Logger &operator << ( int i );
		Logger &operator << ( unsigned int i );
		Logger &operator << ( float i );
		Logger &operator << ( double i );
		Logger &operator << ( char i );
		Logger &operator << ( unsigned char i );
*/				
		
		void write( const string &str );
		void writeLine( const string &str );
		
		void write( const char *fmt, ... );
		void writeLine( const char *fmt, ... );
		
		void close();
	protected:
		void write( const char *str, int length, bool bNewLine );
		void write_var( const char *fmt, va_list ap, bool bNewLine );
		
		vector<ofstream*> m_files;
		
};

#endif
