%option noyywrap

%{
#include "WiimExpert.h"

#include "wiimgram.tab.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif

extern int wiimlex();

extern void wiimparser (WiimExpert *pWiim);

void wiimlex_memory(const char* src, WiimExpert *pWiim)
{
//   cout << src << endl;
   YY_BUFFER_STATE buf_state;
   buf_state = wiim_scan_string(src);
   wiimparser (pWiim);
   wiim_delete_buffer(buf_state);
}

extern int MessageLineNum;

%}


%option noyywrap
%pointer


TEXT [a-zA-Z_][a-zA-Z0-9_]*
BLANK [" "\t]
DIGIT [0-9]
SPACE [" "]
%x HEADER
%%

"#".*           /* eat up comments */
{BLANK}+        /* eat blank spaces */
\n              /* eat up all newline*/ {MessageLineNum++;}

"<MESSAGE"	{ BEGIN(HEADER); 
		  return OPEN_MESSAGE_HEADER;}
<HEADER>">"     { BEGIN(INITIAL); 
		  return CLOSE_HEADER;}
<HEADER>.	{}
">"		{ return CLOSE_HEADER;}
"</MESSAGE>"    { return CLOSE_MESSAGE;}
"="             { return EQUAL;}
"id"            { return MESSAGE_ID;}
"timestamp"     { return TIMESTAMP;}
"sender"        { return SENDER;}
"module"        { return MODULE;}

"<C>"		{ return OPEN_COMMAND;}
"</C>"		{ return CLOSE_COMMAND;}


{TEXT}          {  
		  wiimlval.string = (char*)strdup(wiimtext); 
		  return NAME; 
		}

[-+]?{DIGIT}+(\.{DIGIT}+)?	{	
				  *(wiimtext+wiimleng)='\0';
				  wiimlval.value=atof(wiimtext);
				  return VALUE;
				}
%%
