#include "Spykee.h"
#include "string.h"
#include "pthread.h"

typedef struct{
	TCPSocket* sock;
	char buffer[300];
	int lenBuffer;
	bool free;
} structRecv;

#include <sstream>
using namespace std;

void HandleTCPClient(TCPSocket *sr);     // TCP client handling function
void *ThreadMain(void *arg);               // Main program of a thread 

Spykee::Spykee(const string &user, const string &pass){
	UDPSocket udp;
	char UDPMessage[] = {68, 83, 67, 86, 01};
	char respString[100] = {0};
	char message[] = {80, 75, 10, 00, 12};
	//char *messageAuthentication = new char[user.length() + pass.length() + 2];
	ostringstream oss;
	string sourceAddress;
	unsigned short port;
	pthread_t threadID;
	structRecv sr;
	
	udp.sendTo(UDPMessage, 5, "172.17.6.255", 9000);
	
	if (udp.recvFrom(respString, 100, sourceAddress, port) > 0)
		cout << (char*)(respString + 7) << endl;
	
	tcp = new TCPSocket(sourceAddress, 9000);
	
	tcp->send(message, 5);
	
	oss << (char)user.length();
	oss << user.c_str();
	oss << (char)pass.length();
	oss << pass.c_str();
	tcp->send( oss.str().c_str(), oss.str().length() );

	/*
	messageAuthentication[0] = 5;
	for (int i = 0; i < strlen(user); i++)	{
		messageAuthentication[1 + i] = user[i];
	}

	messageAuthentication[1 + strlen(user)] = 5;
	for (int i = 0; i <  strlen(pass); i++){
		messageAuthentication[2 + strlen(user) + i] = pass[i];
	}

	tcp->send(messageAuthentication, strlen(user) + strlen(pass) + 2);
	*/
	
	if (tcp->recv(respString, 100) > 0)
		cout << (char*)(respString+7) << endl;
	
	sr.sock = tcp;
	sr.lenBuffer = 0;
	sr.free = true;
	
	//delete [] messageAuthentication;
	
	//Viene creato un thread per la ricezione dei messaggi
	//pthread_create(&threadID, NULL, ThreadMain, (void *) tcp);
	
	state |= Connected;
	
	m_iOutBufferSize = 10000;
	m_pJpegOutBuffer = new unsigned char[m_iOutBufferSize];
	memset( m_pJpegOutBuffer, 0, m_iOutBufferSize );
}

void Spykee::unplug()
{
	char message[] = {80, 75, 16, 00, 1};
	tcp->send(message, 5);
	message[0] = 5;
	tcp->send(message, 1);
}

void Spykee::setplug()
{
	char message[] = {80, 75, 16, 00, 1};
	tcp->send(message, 5);
	message[0] = 5;
	tcp->send(message, 1);
}

void Spykee::soundAllarm()
{
	char message[] = {80, 75, 7, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	tcp->send(message, 5);
	if (tcp->recv(message, 15) > 0)
	{
		message[0] = 0;
		tcp->send(message, 1);
	}
}

void Spykee::soundBomb()
{
	char message[] = {80, 75, 7, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	tcp->send(message, 5);
	if (tcp->recv(message, 15) > 0)
	{
		message[0] = 1;
		tcp->send(message, 1);
	}
}

void Spykee::turnOnCameraLight()
{
	//printf("\nACCENSIONE!!");
	char message[] = {80, 75, 4, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	tcp->send(message, 5);
	//if (tcp->recv(message, 15) > 0)
	{
		message[0] = 0;
		message[1] = 1;
		tcp->send(message, 2);
		//printf("\nACCESA!!!");
	}
}

void Spykee::turnOffCameraLight()
{
	//printf("\nSPEGNIMENTO!!");
	char message[] = {80, 75, 4, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	tcp->send(message, 5);
	//if (tcp->recv(message, 15) > 0)
	{
		message[0] = 0;
		message[1] = 0;
		tcp->send(message, 2);
		printf("\nSPENTA!!!");
	}
}

void Spykee::move(int leftSpeed, int rightSpeed){
	//int lSpeed = leftSpeed ((leftSpeed * 98.0) / 100) +	 25;
	//int rSpeed = ((rightSpeed * 98.0) / 100) + 25;
	
	if ((leftSpeed != 0) && (rightSpeed != 0))
	{
		state |= Moving;
	}
	else
	{
		state &= ~Moving;
	}
	
	//leftSpeed = rightSpeed = 100;
	
	char message[] = {80, 75, 5, 0, 2};
	char speedMessage[] = {125-(125-leftSpeed), 125-(125-rightSpeed)};
	//printf("\nLeftMotor: %d, RightMotor: %d", speedMessage[0], speedMessage[1]);
	tcp->send(message, 5);
	tcp->send(speedMessage, 2);
}

void Spykee::startCamera()
{
	char respString[100];
	int dimPackets = 0, bytesRecived;
	char firstMessage[] = {80, 75, 15, 0, 2};
	char secondMessage[] = {1, 1, 80, 75, 15, 0, 2, 2, 1};
	FILE* imm;
	
	tcp->send(firstMessage, 5);
	tcp->send(secondMessage, 9);
	
	state |= CameraOn;
}

unsigned char *Spykee::getImage( int &iOutImageSize, bool bLock ){	
	if ( ((state & Connected) == Connected) && ((state & CameraOn) == CameraOn) ){
		memset( m_pJpegOutBuffer, 0, m_iOutBufferSize );
		unsigned char *buffer = new unsigned char[ 1500 ];
		
		int iImageSize = 0;
		int iBufferSize = 0;
		int iRemaining = 0;
		int iOffset = 0;
		
		ImageState state = WaitForImage;
		
		while ( ( iBufferSize = tcp->recv( buffer, 1500 ) ) > 0 ){
		//	printf( "Buffer size: %d\n", iBufferSize );
		
			if ( state == WaitForImage ){
				if ( buffer[0] == 0x50 && buffer[1] == 0x4b && buffer[2] == 0x02 ){		// Jpeg header received
					iRemaining = iImageSize = (buffer[3] << 8) + buffer[4];
					unsigned char *pJpegData = buffer + 5;
					
					if ( m_iOutBufferSize < iImageSize ){	// Se il buffer non è abbastanza grande lo rialloco
						delete [] m_pJpegOutBuffer;
						m_iOutBufferSize = iImageSize;
						m_pJpegOutBuffer = new unsigned char[m_iOutBufferSize];
					}
					
//					printf( "Jpeg detected. Size: %d", iImageSize );
				
					if ( pJpegData[0] != 0xFF || pJpegData[1] != 0xD8 ){
						printf( "Image header error\n" );
						return NULL;
					}
					
					memcpy( m_pJpegOutBuffer, pJpegData, iBufferSize - 5 );
					iRemaining -= ( iBufferSize - 5 );
					iOffset = (iBufferSize - 5);
					
//					printf( "Remaining %d - Offset: %d\n", iRemaining, iOffset );
					
					state = Processing;
				}
				
			} else if ( state == Processing ){
				if ( iBufferSize < iRemaining ){
					memcpy( &m_pJpegOutBuffer[iOffset], buffer, iBufferSize );
					iRemaining -= iBufferSize;
					iOffset += iBufferSize;
				
//					printf( "Remaining %d - Offset: %d\n", iRemaining, iOffset );
					
				} else {
					memcpy( &m_pJpegOutBuffer[iOffset], buffer, iRemaining );
					iOffset += iRemaining;
					
					state = WaitForImage;
					iOutImageSize = iImageSize;
					
					if ( m_pJpegOutBuffer[iImageSize - 2] != 0xFF || m_pJpegOutBuffer[iImageSize-1] != 0xD9 )
						printf( "Error in image trailer" );
					
					iRemaining -= iRemaining;
					
					//cout << "S: " << iRemaining << endl;
					//if ( iRemaining > 0 )
					//	cout << "Other data in the buffer!!!" << endl;

//					printf( "Remaining %d - Offset: %d\n", iRemaining, iOffset );
					
					return m_pJpegOutBuffer;
				}
				
			}
		}
		
				
		delete [] buffer;
	}
}

Spykee::~Spykee(){
	if ( m_pJpegOutBuffer )
		delete [] m_pJpegOutBuffer;
}

int Spykee::getState()
{
	return (enum states) state;
}

// TCP client handling function
void HandleTCPClient(TCPSocket *sock) {
	unsigned char buffer[1460];
	int recvMsgSize;
	while ((recvMsgSize = sock->recv(buffer, 1460)) > 0) {
		//printf("\nRICEVUTO MESSAGGIO");
		//fflush(stdin);
		Spykee::pharseMessage(buffer, &recvMsgSize, NULL, Spykee::pharseNewMessage);
		//printf("\nFINE ANALISI");
		//fflush(stdin);
	}
}

void *ThreadMain(void *clntSock) {
	// Guarantees that thread resources are deallocated upon return  
	pthread_detach(pthread_self()); 
	
	// Extract socket file descriptor from argument  
	HandleTCPClient((TCPSocket *) clntSock);
	
	//delete (TCPSocket *) clntSock;
	return NULL;
}

